<!doctype html>
<html xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'}">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/js/vendor/viewer/viewer.min.css">
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row layui-col-space15">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <input type="hidden" id="userExpand" th:value="${userExpand}" th:if="${userExpand}">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入用户名、昵称">
                        </div>
                        最后登录
                        <div class="layui-inline">
                            <input type="text" id="startTime" class="layui-input search-item search-item-width-100" placeholder="开始时间" readonly>
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="endTime" class="layui-input search-item search-item-width-100" placeholder="结束时间" readonly>
                        </div>
                        <div class="layui-inline layui-form search-item">
                            <select id="userType" name="userType" lay-filter="typeFilter">
                                <option value="">选择类型</option>
                                <option value="1">系统用户</option>
                                <option value="2">普通用户</option>
                                <option value="3">公共用户</option>
                            </select>
                        </div>
                        <div class="layui-inline layui-form search-item">
                            <select id="userState" name="userState" lay-filter="typeFilter">
                                <option value="">选择类型</option>
                                <option value="0">正常</option>
                                <option value="1">锁定</option>
                                <option value="-1">未审核</option>
                                <option value="-2">审核不通过</option>
                            </select>
                        </div>
                        <div class="layui-btn-group">
                            <button type="button" id="search" class="layui-btn layui-btn-sm">
                                <i class="fa fa-lg fa-search"></i> 搜索
                            </button>
                            <button type="button" class="layui-btn layui-btn-sm layui-btn-primary" id="uploadExcel">
                                <i class="fa fa-lg fa-cloud-upload"></i> 导入数据
                            </button>
                        </div>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="saveEvent">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="updateEvent">
                                <i class="fa fa-lg fa-edit"></i> 编辑
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="removeEvent">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script th:inline="javascript">
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'upload'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var layer = layui.layer;
        var laydate = layui.laydate;
        var windowWidth = $(window).width();
        var windowHeight = $(window).height();
        var resizeTimeout = null;
        var tableUrl = 'api/user/listpage';
        var expandOption = [[${expandOption}]];

        // 初始化表格
        function initTable() {
            var colsArray = [
                {type:'checkbox', fixed: 'left'},
                {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                {field:'userUsername', width:140, title: '用户名', sort: true, align:'center',
                    templet: function(rowData) {
                        return '<a href="javascript:void(0);" lay-event="userUsernameEvent">'+ rowData.userUsername +'</a>';
                    }
                },
                {field:'userName', width:140, title: '昵称', sort: true, align:'center'},
                {field:'userType', width:90, title: '类型', sort: true, align:'center',
                    templet: function(item) {
                        if(item.userType == 1) {
                            return '<span class="layui-badge layui-bg-green">系统用户</span>';
                        } else if(item.userType == 2) {
                            return '<span class="layui-badge layui-bg-orange">普通用户</span>';
                        } else if(item.userType == 3) {
                            return '<span class="layui-badge layui-bg-gray">公共用户</span>';
                        }
                        return '<span class="layui-badge">类型错误</span>';
                    }
                },
                {field:'userState', width:80, title: '状态', sort: true, align:'center',
                    templet: function(item) {
                        var value;
                        switch (item.userState) {
                            case 1:
                                value = '<span class="layui-badge layui-bg-blue">锁定</span>';
                                break;
                            case -1:
                                value = '<span class="layui-badge layui-bg-gray">未审核</span>';
                                break;
                            case -2:
                                value = '<span class="layui-badge">审核不通过</span>';
                                break;
                            default:
                                value = '<span class="layui-badge layui-bg-green">正常</span>';
                        }
                        return value;
                    }
                },
                {field:'userPhone', width:140, title: '手机', sort: true, align:'center',
                    templet: function(item) {
                        if(!item.userPhone) {
                            return '-';
                        }
                        return item.userPhone;
                    }
                },
                {field:'userEmail', width: 160, title: '邮箱', sort: true, align:'center',
                    templet: function(item) {
                        if(!item.userEmail) {
                            return '-';
                        }
                        return item.userEmail;
                    }
                },
                {field:'userExpiredDate', width:180, title: '账号过期时间', align:'center',
                    templet: function(item) {
                        if(!item.userExpiredDate) {
                            return '<button type="button" class="layui-btn layui-btn-xs layui-btn-normal" lay-event="userExpiredDateEvent">' +
                                '<i class="fa fa-clock-o"></i> 设置时间' +
                                '</button>';
                        }
                        return item.userExpiredDate;
                    }
                },
                {field:'lastLoginAddress', width:140, title: '登录地址', align:'center',
                    templet: function(item) {
                        if(!item.lastLoginAddress) {
                            return '-';
                        }
                        return item.lastLoginAddress;
                    }
                },
                {field:'lastLoginTime', width:180, title: '最后登录系统时间', align:'center',
                    templet: function(item) {
                        if(!item.lastLoginTime) {
                            return '-';
                        }
                        return item.lastLoginTime;
                    }
                },
                {field:'gmtCreate', width:180, title: '创建时间', align:'center',
                    templet: function(item) {
                        if(!item.gmtCreate) {
                            return '-';
                        }
                        return item.gmtCreate;
                    }
                },

            ];
            if($('#userExpand') && $('#userExpand').val()) {
                colsArray.push({
                    field:'opition', width:190, title: '操作', fixed:'right', align:'center', templet: function(item) {
                        return '<div class="layui-btn-group">' +
                            '<button type="button" class="layui-btn layui-btn-xs" lay-event="resetPasswordEvent"><i class="fa fa-key"></i> 重置密码</button>'+
                            '<button type="button" class="layui-btn layui-btn-xs layui-btn-primary" lay-event="userExpandEvent"><i class="fa fa-vcard"></i> 拓展属性</button>'+
                            '</div>';
                    }
                });
            } else {
                colsArray.push({
                    field:'opition', width:110, title: '操作', fixed:'right', align:'center', templet: function(item) {
                        return '<button type="button" class="layui-btn layui-btn-xs" lay-event="resetPasswordEvent">' +
                            '<i class="fa fa-key"></i> 重置密码' +
                            '</button>';
                    }
                });
            }
            if(expandOption) {
                colsArray.push({
                    field:'expandOpition', width: expandOption.width, title: expandOption.title, fixed: expandOption.fixed, align: expandOption.align, templet: function(item) {
                        var btns = '<div class="layui-btn-group">';
                        for(var i = 0, item; item = expandOption.btns[i++];) {
                            btns += '<button type="button" class="layui-btn layui-btn-xs" lay-event="expandOpitionEvent" data-route="'+ item.route +'" data-title="'+ item.title +'">'+ item.title +'</button>';
                        }
                        btns += '</div>';
                        return btns;
                    }
                });
            }
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    colsArray
                ],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, []),
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val(),
                    userType: $('#userType').val(),
                    userState: $('#userState').val()
                },
                page: {
                    curr: currentPage
                },
                height: $win.height() - 90,
            });
        }
        // 初始化日期
        function initDate() {
            // 日期选择
            laydate.render({
                elem: '#startTime',
                format: 'yyyy-MM-dd'
            });
            laydate.render({
                elem: '#endTime',
                format: 'yyyy-MM-dd'
            });
        }
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/user/remove/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        initTable();
        initDate();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });
        $(document).on('click', '#uploadExcel', function() {
            top.dialog.open({
                url: top.restAjax.path('route/user/upload/upload-excel', []),
                title: '导入用户数据',
                width: '300px',
                height: '196px',
                onClose: function() {
                    reloadTable();
                }
            });
        });
        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'saveEvent') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/user/save', []),
                    end: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'updateEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    layer.open({
                        type: 2,
                        title: false,
                        closeBtn: 0,
                        area: ['100%', '100%'],
                        shadeClose: true,
                        anim: 2,
                        content: top.restAjax.path('route/user/update?userId={id}', [checkDatas[0].userId]),
                        end: function() {
                            reloadTable();
                        }
                    });
                }
            } else if(layEvent === 'removeEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item.userId;
                    }
                    removeData(ids);
                }
            }
        });
        table.on('tool(dataTable)', function(obj) {
            var layEvent = obj.event;
            var data = obj.data;
            if(layEvent === 'userUsernameEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/user/update-username?userId={userId}', [data.userId]),
                    title: '【'+ data.userName +'】修改用户名',
                    width: '320px',
                    height: '430px',
                    onClose: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'resetPasswordEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/user/rest-password?userId={userId}', [data.userId]),
                    title: '【'+ data.userName +'】重置密码',
                    width: '320px',
                    height: '280px',
                    onClose: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'userExpiredDateEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/user/update-expired-date?userId={userId}', [data.userId]),
                    title: '【'+ data.userName +'】设置账号过期时间',
                    width: '274px',
                    height: '395px',
                    onClose: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'userExpandEvent') {
                top.dialog.open({
                    url: top.restAjax.path('{userExpand}?userId={userId}', [$('#userExpand').val(), data.userId]),
                    title: '【'+ data.userName +'】拓展属性',
                    width: '60%',
                    height: '80%',
                    onClose: function() {}
                });
            } else if(layEvent === 'expandOpitionEvent') {
                top.dialog.open({
                    url: top.restAjax.path('{userExpandOptionRoute}?userId={userId}', [this.dataset.route, data.userId]),
                    title: '【'+ data.userName +'】'+ this.dataset.title,
                    width: '60%',
                    height: '80%',
                    onClose: function() {}
                });
            }
        });
        // 事件-排序
        table.on('sort(dataTable)', function(obj) {
            table.reload('dataTable', {
                initSort: obj,
                where: {
                    sort: obj.field,
                    order: obj.type
                }
            });
        });
    });
</script>
</body>
</html>